package gov.va.claims.attachments.database;

import java.sql.*;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;


import com.microsoft.sqlserver.jdbc.SQLServerConnection;

/**
 * preliminary connection string - needs to be read from db.properties file.
  * 
 * Draft of DB connectivity etc.
 * @author DOMAINBLACKW
 * @since 8/4/2014
 */

public class AttachmentsSQLServerConnection {
	static final Logger Log = LoggerFactory.getLogger(AttachmentsSQLServerConnection.class);
	
	SQLServerConnection connection = null;
  
	String url="";
	String port="";
	String database="";
	String user="";
	String password="";
	String connectionString = "";
	
	final static String COLON=":";
	final static String COMMA = ",";
	final static String SLASH = "/";
	final static String SEMI_COLON=";";
	final static String DB_STRING = "database=";
	
	/**
			port=1521
			database=XE
			user=system
			password=password
	**/		
	
	// def. constr()
     public AttachmentsSQLServerConnection() {}
     
     // full constr()
     public AttachmentsSQLServerConnection(String url, String database, String user, String password, String port) {
    	 this.url = url;
    	 this.database = database;
    	 this.user = user;
    	 this.password = password;
    	 this.port = port;
    	 setConnectionString();
    	 setSQLServerConnection();
       }
     
     private void setConnectionString() {
    	// String url = "jdbc:sqlserver://VHAHACSQL2K8HD:1433;databaseName=CLAIMS_ATTACHMENTS";
    	 //              jdbc:sqlserver://VHAHACSQL2K8HD:1433:CLAIMS_ATTACHMENTS,test,test
     	 connectionString = this.url + this.COLON + this.port + this.SEMI_COLON + this.DB_STRING + this.database;// + COMMA;	+ this.user + COMMA + this.password;
    	 // System.out.println("setConnectionString() - con String is: " + connectionString);
       }	// end setConnectionString()
     
     public void setSQLServerConnection() {
		
			try {
					Class.forName("com.microsoft.sqlserver.jdbc.SQLServerDriver");
						   
					connection = (SQLServerConnection) DriverManager.getConnection(connectionString, this.user, this.password); 
					System.out.println("setSQLServerConnection() - Retrieved DB connection");
					
			} catch (SQLException e) {
				Log.error(e.getMessage());
				e.printStackTrace();
			} catch (ClassNotFoundException e) {
				Log.error(e.getMessage());
				e.printStackTrace();
			} 
			
	}	// end setSQLServerConnection()
	
	
    public void closeConnection() {
    	if(connection != null) {
    		try {
				connection.close();
				
Log.debug("closeConnection() - connection closed");	
System.out.println("closeConnection() - connection closed");

			} catch (SQLException e) {
				// TODO Auto-generated catch block
				Log.error(e.getMessage());
				e.printStackTrace();
			}
    	} else {
    		Log.debug("closeConnection() - ERROR - trying to close a NULL connection!");
    	}
    }
     
	public String getUrl() {
		return url;
	}

	public void setUrl(String url) {
		this.url = url;
	}

	public String getPort() {
		return port;
	}

	public void setPort(String port) {
		this.port = port;
	}

	public String getDatabase() {
		return database;
	}

	public void setDatabase(String database) {
		this.database = database;
	}

	public String getUser() {
		return user;
	}

	public void setUser(String user) {
		this.user = user;
	}

	public String getPassword() {
		return password;
	}

	public void setPassword(String password) {
		this.password = password;
	}

	/**
	public void setConnection(oracle.jdbc.OracleConnection connection) {
		this.connection = connection;
	}
	**/


	public SQLServerConnection getConnection() {
		return connection;
	}
/**
	public PreparedStatement prepareStatement(String insertClaimsAttachment) {
		// TODO Auto-generated method stub
		return null;
	}
**/	

}	// end class

