package gov.va.claims.attachments.model;

// import gov.va.claims.attachments.AttachmentsMain;
// import gov.va.claims.attachments.parser.X275;
// import gov.va.claims.attachments.parser.helpers.Segment;

// import java.sql.Blob;
// import java.sql.Date;
import java.text.SimpleDateFormat;
// import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;


/**
 * Bean class for CLAIMS_ATTACHMENT table
 * @author DOMAINBLACKW
 * @since 8/12/2014
 *
 */
public class ClaimsAttachment {
	
	// fields
	
	/**
	    Id	Bigint
		Provider Name	Varchar(132)
		Provider Identification Number	Varchar(20)
		Patient Name	Varchar(60)
		Patient Identification Number	Varchar(20)
		Claim Identifier	Varchar(20)
		Claim Service Date	Date
		Attachment Control Number	Varchar(20)
		Attachment	NVarchar(MAX)
	 */

	static final Logger Log = LoggerFactory.getLogger(ClaimsAttachment.class);
	// private static Logger Log = Logger.getLogger(ClaimsAttachment.class.getName());

	
	private boolean DEBUG = false;
	
	private String providerName;
	private String providerIdentificationNumber;
	private String patientName;
	private String patientID;

	private String claimIdentifier;
	private String claimServiceDate;
	private String attachmentControlNumber;
	// private Blob attachment;
	private String attachment;
	private String fileType;
	
	// byte[] fdata
	// private byte[] fullFile;	//entire file read from wherever.........
	private String fullFile;
	
	private byte[] bFullFile;
	private byte[] bAttachment;
	
	// def. constr()
	public ClaimsAttachment() {}
	
	

	
	// Constructor for File input
	public ClaimsAttachment(String providerName, String providerIdentificationNumber, String patientName, String patientID, String claimIdentifier, 
			String claimServiceDate, String attachmentControlNumber,
			String attachment,  String fullFile) {
		
		this.providerName = providerName;
		this.providerIdentificationNumber = providerIdentificationNumber;
		this.patientName = patientName;
		this.patientID = patientID;
		this.claimIdentifier = claimIdentifier;
		this.claimServiceDate = claimServiceDate;
		this.attachmentControlNumber = attachmentControlNumber;
		this.attachment = attachment;
		// this.fileType = fileType;
		this.fullFile = fullFile;			// kept for reference
		
		// if()
	}	// end constr()
	
	
	// ClaimsAttachment claimsAttachment = new ClaimsAttachment(sPN, sPID, sPatN, sCID, sCSD, sACN, sFullFile);
	// constructor for paper input - no 'attachment' - entire file goes into attachment field in DB
	public ClaimsAttachment(String providerName, String providerIdentificationNumber, String patientName, String patientID, String claimIdentifier, 
			String claimServiceDate, String attachmentControlNumber,
			String fullFile) {
		
		this.providerName = providerName;
		this.providerIdentificationNumber = providerIdentificationNumber;
		this.patientName = patientName;
		this.patientID = patientID;
		this.claimIdentifier = claimIdentifier;
		this.claimServiceDate = claimServiceDate;
		this.attachmentControlNumber = attachmentControlNumber;
		this.attachment = fullFile;
		// this.fileType = fileType;
		this.fullFile = fullFile;
	}
	
	
	
	
	
	
	
	
	public String getProviderName() {
		return providerName;
	}
	public void setProviderName(String providerName) {
		this.providerName = providerName;
	}
	public String getProviderIdentificationNumber() {
		return providerIdentificationNumber;
	}
	public void setProviderIdentificationNumber(String providerIdentificationNumber) {
		this.providerIdentificationNumber = providerIdentificationNumber;
	}
	public String getPatientName() {
		return patientName;
	}
	public void setPatientName(String patientName) {
		this.patientName = patientName;
	}
	
	public String getPatientID() {
		return patientID;
	}




	public void setPatientID(String patientID) {
		this.patientID = patientID;
	}
	public String getClaimIdentifier() {
		return claimIdentifier;
	}
	public void setClaimIdentifier(String claimIdentifier) {
		this.claimIdentifier = claimIdentifier;
	}
	
	
	public java.sql.Date  getClaimServiceDate() {
		
		// create a new Date here and return it to see if it will fit in DB....
		// Date Expressed in Format CCYYMMDD for testing 
		
		if(DEBUG) {
			Log.debug("getClaimServiceDate() - String claimServiceDate is: " + claimServiceDate);
			System.out.println("getClaimServiceDate() - String claimServiceDate is: " + claimServiceDate);
		}
			java.sql.Date csDate = null;
			java.util.Date plainDate = null;
	
		/**
		 *  Date sampleDate = null;  
	        SimpleDateFormat sdf = new SimpleDateFormat( "yyyyMMdd" );  
	        String sampleDateString = "19700120";  
		 */
	
		if( (claimServiceDate) != null && (claimServiceDate.length() > 0) )	
			try {
				SimpleDateFormat sdf = new SimpleDateFormat( "yyyyMMdd" );
				// get the plain  date from the String
				plainDate = sdf.parse(claimServiceDate.trim()); 
				// create the new sql date from the time
				csDate = new java.sql.Date(plainDate.getTime());
			}catch(Exception e) {
				Log.error("ClaimsAttachment.getClaimServiceDate() error: " + e.getMessage());
				e.printStackTrace();
			}
		// 1969-12-31	- date written into db from String input file value of 20100720 - go figure 
		return csDate;	// return claimServiceDate;
	}	// end getClaimServiceDate() 
	
	
	
	public void setClaimServiceDate(String claimServiceDate) {
		this.claimServiceDate = claimServiceDate;
	}
	public String getAttachmentControlNumber() {
		return attachmentControlNumber;
	}
	public void setAttachmentControlNumber(String attachmentControlNumber) {
		this.attachmentControlNumber = attachmentControlNumber;
	}
	public String getAttachment() {
		return attachment;
	}
	public void setAttachment(String attachment) {
		this.attachment = attachment;
	}
	public String getFileType() {
		return fileType;
	}
	public void setFileType(String fileType) {
		this.fileType = fileType;
	}


	public String getFullFile() {
		return fullFile;
	}


	public void setFullFile(String fullFile) {
		this.fullFile = fullFile;
	}




	public byte[] getbFullFile() {
		return bFullFile;
	}




	public void setbFullFile(byte[] bFullFile) {
		this.bFullFile = bFullFile;
	}




	public byte[] getbAttachment() {
		return bAttachment;
	}




	public void setbAttachment(byte[] bAttachment) {
		this.bAttachment = bAttachment;
	}




	@Override
	public String toString() {
		return "ClaimsAttachment [providerName=" + providerName
				+ ", providerIdentificationNumber="
				+ providerIdentificationNumber + ", patientName=" + patientName
				+ ", patientID=" + patientID + ", claimIdentifier="
				+ claimIdentifier + ", claimServiceDate=" + claimServiceDate
				+ ", attachmentControlNumber=" + attachmentControlNumber
				+ ", attachment=" + attachment + ", fileType=" + fileType
				+ ", fullFile=" + fullFile + "]";
	}




	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result
				+ ((attachment == null) ? 0 : attachment.hashCode());
		result = prime
				* result
				+ ((attachmentControlNumber == null) ? 0
						: attachmentControlNumber.hashCode());
		result = prime * result
				+ ((claimIdentifier == null) ? 0 : claimIdentifier.hashCode());
		result = prime
				* result
				+ ((claimServiceDate == null) ? 0 : claimServiceDate.hashCode());
		result = prime * result
				+ ((fileType == null) ? 0 : fileType.hashCode());
		result = prime * result
				+ ((fullFile == null) ? 0 : fullFile.hashCode());
		result = prime * result
				+ ((patientID == null) ? 0 : patientID.hashCode());
		result = prime * result
				+ ((patientName == null) ? 0 : patientName.hashCode());
		result = prime
				* result
				+ ((providerIdentificationNumber == null) ? 0
						: providerIdentificationNumber.hashCode());
		result = prime * result
				+ ((providerName == null) ? 0 : providerName.hashCode());
		return result;
	}




	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		ClaimsAttachment other = (ClaimsAttachment) obj;
		if (attachment == null) {
			if (other.attachment != null)
				return false;
		} else if (!attachment.equals(other.attachment))
			return false;
		if (attachmentControlNumber == null) {
			if (other.attachmentControlNumber != null)
				return false;
		} else if (!attachmentControlNumber
				.equals(other.attachmentControlNumber))
			return false;
		if (claimIdentifier == null) {
			if (other.claimIdentifier != null)
				return false;
		} else if (!claimIdentifier.equals(other.claimIdentifier))
			return false;
		if (claimServiceDate == null) {
			if (other.claimServiceDate != null)
				return false;
		} else if (!claimServiceDate.equals(other.claimServiceDate))
			return false;
		if (fileType == null) {
			if (other.fileType != null)
				return false;
		} else if (!fileType.equals(other.fileType))
			return false;
		if (fullFile == null) {
			if (other.fullFile != null)
				return false;
		} else if (!fullFile.equals(other.fullFile))
			return false;
		if (patientID == null) {
			if (other.patientID != null)
				return false;
		} else if (!patientID.equals(other.patientID))
			return false;
		if (patientName == null) {
			if (other.patientName != null)
				return false;
		} else if (!patientName.equals(other.patientName))
			return false;
		if (providerIdentificationNumber == null) {
			if (other.providerIdentificationNumber != null)
				return false;
		} else if (!providerIdentificationNumber
				.equals(other.providerIdentificationNumber))
			return false;
		if (providerName == null) {
			if (other.providerName != null)
				return false;
		} else if (!providerName.equals(other.providerName))
			return false;
		return true;
	}




	
	

}	// end class
