package gov.va.claims.attachments.model;

// import gov.va.claims.attachments.AttachmentsMain;
import gov.va.claims.attachments.database.AttachmentsSQLServerConnection;

import java.sql.PreparedStatement;
// import java.sql.SQLException;
// import java.util.ArrayList;
// import java.util.Collection;
import com.microsoft.sqlserver.jdbc.SQLServerConnection;
import com.microsoft.sqlserver.jdbc.SQLServerException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;


/**
 * Rough draft of SQL methods for ClaimsAttachment against SQL Server DB
 * since 8/21/2014
 * @author DOMAINBLACKW
 *
 **/

public class SQLServerClaimsAttachmentDAO {
	
	boolean DEBUG = true; 
	
	static final Logger Log = LoggerFactory.getLogger(SQLServerClaimsAttachmentDAO.class);

	public int insertClaimsAttachment(AttachmentsSQLServerConnection con, ClaimsAttachment ca) {
		
		SQLServerConnection sqlConnection = con.getConnection();
		
		
		
		String insertClaimsAttachment = "INSERT INTO dbo.CLAIMS_ATTACHMENTS" +
		"(PROVIDER_NAME, PROVIDER_IDENTIFIER_NUMBER, PATIENT_NAME, PATIENT_IDENTIFIER_NUMBER, " +
		" CLAIM_IDENTIFIER, CLAIM_SERVICE_DATE, ATTACHMENT_CONTROL_NUMBER, ATTACHMENT) VALUES"
		+ "(?,?,?,?,?,?,?,?)";
		
			
		try {
			
			PreparedStatement preparedStatement = sqlConnection.prepareStatement(insertClaimsAttachment);	//prepareStatement(insertClaimsAttachment);

			preparedStatement.setString(1, ca.getProviderName());
			preparedStatement.setString(2, ca.getProviderIdentificationNumber());
			preparedStatement.setString(3, ca.getPatientName());
			preparedStatement.setString(4, ca.getPatientID());
			preparedStatement.setString(5, ca.getClaimIdentifier());
			
			// TEST THIS AS A STRING FIRST TO SEE IF IT'S ACCEPTED.....IF SO, FORMAT IT UPON READING DEPENDING ON THE FORMAT QUALIFIER....which is not saved anyplace.
			// preparedStatement.setString(6, ca.getClaimServiceDate());
			preparedStatement.setDate(6, ca.getClaimServiceDate());			// insert claim service date
			preparedStatement.setString(7, ca.getAttachmentControlNumber());
	
/**			
if(DEBUG) {			
Log.debug("insertClaimsAttachment() - size of attachment is: " + x);	
}
			**/
			
			preparedStatement.setString(8, ca.getAttachment());
			
			preparedStatement.executeUpdate();
			
			Log.info("insertClaimsAttachment() - Record inserted successfully");
			
if(DEBUG) {
//	Log.debug("insertClaimsAttachment() - record inserted successfully");
	System.out.println("insertClaimsAttachment() - record inserted successfully");
}
			
			
		}catch(SQLServerException sql) {
			Log.error("insertClaimsAttachement() SQL Exception: " + sql.getMessage());
			sql.printStackTrace();
		}catch(Exception ex) {
			Log.error("insertClaimsAttachement() Exception: " + ex.getMessage());
			ex.printStackTrace();
		}

		
		return 1;
	}	// end insertClaimsAttachment()
	
	
	public boolean deleteClaimsAttachment() {
		return true;
	}
	public ClaimsAttachment findClaimsAttachment() {
		ClaimsAttachment ca = new ClaimsAttachment();
		return ca;
	}
	
	public boolean updateClaimsAttachment() {
		return true;
	}

/**	
	public Collection selectClaimsAttacmentTO() {
		
		ArrayList list = new ArrayList();
		
		return list;
	}
**/


}
