
package gov.va.claims.attachments.parser;

import gov.va.claims.attachments.parser.helpers.Context;
import gov.va.claims.attachments.parser.helpers.EDI;
import gov.va.claims.attachments.parser.helpers.Loop;

/**
 * The building block of an X275 transaction is an element. Some
 * elements may be made of sub elements. Elements combine to form segments.
 * Segments are grouped as loops. And a set of loops form an X12 transaction.
 
 */

public class X275 extends Loop implements EDI {

	/**
	 * The constructor takes a context object.
	 * 
	 * @param c
	 *            a Context object
	 */
	public X275(Context c) {
		super(c, "X275");
	}
}
