package gov.va.claims.attachments.parser.helpers;

/**
 * The class represents an X12 context. A X12 context consists of a segment
 * separator, element separator and a composite element separator.
 * 

 */
public class Context {
	
	private boolean DEBUG = true;
	
	
	private Character segmentSeparator;
	private Character elementSeparator;
	private Character compositeElementSeparator;

	/**
	 * Default constructor.
	 */
	public Context() {

	}

	/**
	 * Constructor which takes the segment separator, element separator and
	 * composite element separator as input.
	 * 
	 * @param s
	 *            segment separator
	 * @param e
	 *            element separator
	 * @param c
	 *            composite element separator
	 */
	public Context(Character s, Character e, Character c) {
		this.segmentSeparator = s;
		
		
		// this.segmentSeparator  = '~';
		
		
if(DEBUG) {
	System.out.println("Context.constr() - segment sepearator is: " + this.segmentSeparator);
}
		
		
		this.elementSeparator = e;
		this.compositeElementSeparator = c;
	}

	public Character getSegmentSeparator() {
		return segmentSeparator;
	}

	public void setSegmentSeparator(Character segmentSeparator) {
		this.segmentSeparator = segmentSeparator;
	}

	public Character getElementSeparator() {
		return elementSeparator;
	}

	public void setElementSeparator(Character elementSeparator) {
		this.elementSeparator = elementSeparator;
	}

	public Character getCompositeElementSeparator() {
		return compositeElementSeparator;
	}

	public void setCompositeElementSeparator(Character compositeElementSeparator) {
		this.compositeElementSeparator = compositeElementSeparator;
	}

	@Override
	public String toString() {
		return "Context [segmentSeparator=" + segmentSeparator
				+ ", elementSeparator=" + elementSeparator
				+ ", compositeElementSeparator=" + compositeElementSeparator
				+ "]";
	}


	
	
}	// end class
